from ._optimize import OptimizeResult as OptimizeResult
from scipy._typing import Untyped
from scipy.optimize._differentiable_functions import FD_METHODS as FD_METHODS
from scipy.optimize._hessian_update_strategy import HessianUpdateStrategy as HessianUpdateStrategy

class BaseQuadraticSubproblem:
    def __init__(self, x, fun, jac, hess: Untyped | None = None, hessp: Untyped | None = None): ...
    def __call__(self, p) -> Untyped: ...
    @property
    def fun(self) -> Untyped: ...
    @property
    def jac(self) -> Untyped: ...
    @property
    def hess(self) -> Untyped: ...
    def hessp(self, p) -> Untyped: ...
    @property
    def jac_mag(self) -> Untyped: ...
    def get_boundaries_intersections(self, z, d, trust_radius) -> Untyped: ...
    def solve(self, trust_radius): ...
