from ._base import sparray as sparray
from ._compressed import _cs_matrix
from ._matrix import spmatrix as spmatrix
from ._sparsetools import csc_tocsr as csc_tocsr, expandptr as expandptr
from ._sputils import upcast as upcast
from scipy._typing import Untyped

__docformat__: str

class _csc_base(_cs_matrix):
    def transpose(self, axes: Untyped | None = None, copy: bool = False) -> Untyped: ...
    def __iter__(self) -> Untyped: ...
    def tocsc(self, copy: bool = False) -> Untyped: ...
    def tocsr(self, copy: bool = False) -> Untyped: ...
    def nonzero(self) -> Untyped: ...

def isspmatrix_csc(x) -> Untyped: ...

class csc_array(_csc_base, sparray): ...
class csc_matrix(spmatrix, _csc_base): ...
