from typing import TypeVar

import numpy as np
import numpy.typing as npt

from ._ckdtree import cKDTree as cKDTree, cKDTreeNode as cKDTreeNode
from scipy._typing import Untyped

__all__ = ["KDTree", "Rectangle", "distance_matrix", "minkowski_distance", "minkowski_distance_p"]

def minkowski_distance_p(x, y, p: int = 2) -> Untyped: ...
def minkowski_distance(x, y, p: int = 2) -> Untyped: ...

class Rectangle:
    maxes: Untyped
    mins: Untyped
    def __init__(self, maxes, mins) -> None: ...
    def volume(self) -> Untyped: ...
    def split(self, d, split) -> Untyped: ...
    def min_distance_point(self, x, p: float = 2.0) -> Untyped: ...
    def max_distance_point(self, x, p: float = 2.0) -> Untyped: ...
    def min_distance_rectangle(self, other: Rectangle, p: float = 2.0) -> Untyped: ...
    def max_distance_rectangle(self, other: Rectangle, p: float = 2.0) -> Untyped: ...

_BoxT = TypeVar("_BoxT", bound=npt.NDArray[np.float64] | None)

class KDTree(cKDTree[_BoxT]):
    class node:
        def __init__(self, ckdtree_node: Untyped | None = None): ...
        def __lt__(self, other: node) -> Untyped: ...
        def __gt__(self, other: node) -> Untyped: ...
        def __le__(self, other: node) -> Untyped: ...
        def __ge__(self, other: node) -> Untyped: ...
        def __eq__(self, other: node) -> Untyped: ...

    class leafnode(node):
        @property
        def idx(self) -> Untyped: ...
        @property
        def children(self) -> Untyped: ...

    class innernode(node):
        less: Untyped
        greater: Untyped
        def __init__(self, ckdtreenode) -> None: ...
        @property
        def split_dim(self) -> Untyped: ...
        @property
        def split(self) -> Untyped: ...
        @property
        def children(self) -> Untyped: ...

def distance_matrix(x, y, p: int = 2, threshold: int = 1000000) -> Untyped: ...
